#include <iostream>
#include <string>

#include "js_typedefs.h"
#include "js_useful_funcs.h"
#include "js_parse_funcs.h"
#include "js_constants.h"

namespace js
{

std::string markerToString(uint16 marker)
{
	switch(marker)
	{
		case marker::SOC:
			return "start of codestream";
		case marker::SOT:
			return "start of tile-part";
		case marker::SOD:
			return "start of data";
		case marker::EOC:
			return "end of codestream";
		case marker::SIZ:
			return "size";
		case marker::COD:
			return "coding style default";
		case marker::COC:
			return "coding style component";
		case marker::RGN:
			return "region of interest";
		case marker::QCD:
			return "quantization default";
		case marker::QCC:
			return "quantization component";
		case marker::POC:
			return "progression order change";
		case marker::PLM:
			return "tile-part lengths";
		case marker::PLT:
			return "packet length, main header";
		case marker::PPM:
			return "packet length, tile-part header";
		case marker::PPT:
			return "packed packet headers, main header";
		case marker::TLM:
			return "packet packet headers, tile-part header";
		case marker::SOP:
			return "start of packet";
		case marker::EPH:
			return "end of packet header";
		case marker::CRG:
			return "component registration";
		case marker::COM:
			return "comment";
		default:
			return "unknown";
	}
}
uint16 bytesToWord(uint8 byte1, uint8 byte2)
{
	uint16 ret = byte1;
	ret <<= 8;
	return (ret | uint16(byte2));
}

} // End namespace js