function L = calcLayers(nLayers, minMbits, maxMbits, sizeBytes, fps)
doprint = false;

rateMax = maxMbits*1000000/(fps*8*sizeBytes); % (Bytes/frame) / size of one full frame = rate
rateMin = minMbits*1000000/(fps*8*sizeBytes);

if(rateMin < 0) 
    rateMin = 0;
end

if(rateMax < 0)
    rateMax = 0;
end

if(rateMax > 1)
    rateMax = 1;
end

if(rateMin > 1)
    rateMin = 1;
end

if(rateMin >= rateMax)
    L = rateMax;
    return;
end  

L = (linspace(rateMin, rateMax, nLayers));

if(doprint)
    for i = 1:length(L)
        fprintf('%f,', L(i))
    end
    fprintf('\n')
end

end