function ret = psnr(im1, im2)

sz1 = size(im1);
sz2 = size(im2);

if(sz1 ~= sz2)
    disp('Unequal sizes in the images');
    return;
end

nComp1 = length(im1(1,1,:));

n = length(im1(:,1,1));
m = length(im1(1,:,1));

im1 = double(im1);
im2 = double(im2);

if(nComp1 == 1)
    MSE1 = sum(sum((im1(:,:,1) - im2(:,:,1)).^2))./(m*n);
    ret = 10*log10(255*255/MSE1);
    return;
end

if(nComp1 == 2)
    ret = 0;
    disp('2 comp image not supported');
    return;
end

Y1 = 0.29900 * im1(:,:,1) + 0.58700 * im1(:,:,2) + 0.11400 * im1(:,:,3);
Y2 = 0.29900 * im2(:,:,1) + 0.58700 * im2(:,:,2) + 0.11400 * im2(:,:,3);

U1 = 0.436*(im1(:,:,3) - Y1)./(1-0.114);
U2 = 0.436*(im2(:,:,3) - Y2)./(1-0.114);

V1 = 0.615*(im1(:,:,1) - Y1)./(1-0.299);
V2 = 0.615*(im2(:,:,1) - Y2)./(1-0.299);


MSEY = sum(sum((Y1(:) - Y2(:)).^2))./(m*n);
MSEU = sum(sum((U1(:) - U2(:)).^2))./(m*n);
MSEV = sum(sum((V1(:) - V2(:)).^2))./(m*n);
PY = 10*log10(255*255/MSEY);
PU = 10*log10(255*255/MSEU);
PV = 10*log10(255*255/MSEV);

ret = [PY PU PV];

end